module doodle.fig.fig;

private {
    import doodle.tk.geometry;
    import cairo.Context;
}

interface FigParent {
}

abstract class Fig {
    Rectangle bounds() const;

    void draw(in Rectangle damage, scope Context cr) const;

    private {
        FigParent mParent;
    }
}

abstract class FigElement : Fig {
    // Link to model via bridge goes here
}

class Connection {
}

class FigNode : FigElement {
}

class FigEdge : FigElement {
    private {
        Connection[] mConnections;
    }
}

abstract class FigLeaf : Fig {
}
